within ;
package mos2 
  model ee "elektricke enelogie" 
    // demonstrace elektrickych analogii - jednoduchy poscilator
    Modelica.Electrical.Analog.Basic.Capacitor capacitor1(C = 1, v(start = 1, fixed = true)) annotation(Placement(visible = true, transformation(origin = {-28, -14}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Electrical.Analog.Basic.Inductor inductor1(L = 1) annotation(Placement(visible = true, transformation(origin = {10, -12}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Electrical.Analog.Basic.Ground ground1 annotation(Placement(visible = true, transformation(origin = {-54, -38}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  equation 
    connect(capacitor1.n, inductor1.p) annotation(Line(points = {{-18, -14}, {0, -14}, {0, -12}, {0, -12}}, color = {0, 0, 255}));
    connect(inductor1.n, capacitor1.p) annotation(Line(points = {{20, -12}, {38, -12}, {38, 34}, {-50, 34}, {-50, -14}, {-38, -14}, {-38, -14}}, color = {0, 0, 255}));
    connect(capacitor1.p, ground1.p) annotation(Line(points = {{-38, -14}, {-54, -14}, {-54, -28}, {-54, -28}}, color = {0, 0, 255}));
    annotation(Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})));
  end ee;
  
  model eq 
    // koment
    /* delsi koment */
    // units jsou nepovinne, usnadnuji nam ale debugging rozsahlejsich modelu
    Real f(unit = "N") "sila";
    Real y(unit = "m") "pozice";
    Real v(start = 1, unit = "m/s");
    Real a(unit = "m.s-2");
    parameter Real m = 1;
    parameter Real k = 1;
  equation 
    // poradi rovnic ani leve a prave strany nejsou dulezite
    // je to vae matematika a ta prav - je to rovnost
    v = der(y);
    f = -k * y;
    -k * y = m * a;
    der(v) = a;
    // anotace jsou jenom pro graficke zobrazeni v diagram view a icon view
    annotation(Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})));
  end eq;
  
  connector con 
    Real y(unit = "m") "pozice v metrech";
    // non flow promenna - v kazdem spojeni konektoru je vzdy rovna
    flow Real f(unit = "N") "sila v newtonech";
    // flow promenna - v kazdem spojeni konektoru se scita do nuly - tj. jedno je kladne, druhe zaporne
    annotation(Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2}), graphics = {Rectangle(origin=  {1, 0}, fillPattern=  FillPattern.Solid, extent=  {{-99, 100}, {99, -100}})}));
  end con;
  
  model pruzina 
    // anotace nemaji vliv na vypocet, jen na zobrazeni modelu
    // objekt con ma instanci con1
    con con1 annotation(Placement(visible = true, transformation(origin = {0, 78}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {0, 78}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    con con2 annotation(Placement(visible = true, transformation(origin = {2, -86}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {2, -86}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    parameter Real k;
  equation 
    con1.f = k * (con1.y - con2.y);
    con1.f + con2.f = 0;
    annotation(Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2}), graphics = {Line(origin=  {14, -4.79835}, points=  {{-14, 66.7984}, {-42, 30.7984}, {46, 30.7984}, {-40, 6.79835}, {50, 0.798354}, {-50, -29.2016}, {14, -27.2016}, {-28, -49.2016}, {-12, -55.2016}, {-12, -67.2016}})}));
  end pruzina;
  
  model kulicka 
    parameter Real m = 1;
    parameter Real initPos;
    // lze napsat i
    // Real y (start = 1);
    Real y;
    Real v;
    con con1 annotation(Placement(visible = true, transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-84, 80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  equation 
    con1.f = m * der(v);
    v = der(y);
    y = con1.y;
    annotation(Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2}), graphics = {Ellipse(origin=  {-1, 2}, extent=  {{-87, 90}, {87, -90}}, endAngle=  360)}));
  end kulicka;
  
  model strop 
    
    con con1 annotation(Placement(visible = true, transformation(origin = {0, -84}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {0, -84}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Blocks.Interfaces.RealInput u annotation(Placement(visible = true, transformation(origin = {-96, 86}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-84, 82}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
  equation 
    con1.y = u;
    annotation(Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2}), graphics = {Rectangle(origin=  {1, -1}, extent=  {{-85, 83}, {85, -83}})}));
  end strop;
  
  model system 
    
    kulicka kulicka1(initPos = 0) annotation(Placement(visible = true, transformation(origin = {6, -44}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    pruzina pruzina1(k = 1) annotation(Placement(visible = true, transformation(origin = {-8, 8}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    strop strop1 annotation(Placement(visible = true, transformation(origin = {-10, 68}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Blocks.Sources.Sine sine1(freqHz = 0.25, startTime = 1) annotation(Placement(visible = true, transformation(origin = {-74, 68}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
    kulicka kulicka2(initPos = 1) annotation(Placement(visible = true, transformation(origin = {-30, -46}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    parameter Real pocPoz = 1;
  initial equation 
    kulicka1.con1.y = pocPoz;
    
  equation 
    connect(kulicka1.con1, kulicka2.con1) annotation(Line(points = {{-2, -36}, {-38, -36}, {-38, -36}, {-38, -36}}));
    connect(kulicka2.con1, pruzina1.con2) annotation(Line(points = {{-38, -38}, {-8, -38}, {-8, 0}, {-8, 0}}));
    connect(strop1.u, sine1.y) annotation(Line(points = {{-18, 76}, {-25.5, 76}, {-25.5, 68}, {-52, 68}}, color = {0, 0, 127}));
    connect(strop1.con1, pruzina1.con1) annotation(Line(points = {{-10, 60}, {-10, 38}, {-8, 38}, {-8, 16}}));
    annotation(Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})));
  end system;
  
  model balonyEq 
    parameter Real c1 = 1, c2 = 1, r = 1;
    Real v1, p1, q1_b, q1_r;
    Real v2, p2, q2_b, q2_r;
  initial equation 
    v1 = 2;
    v2 = 0;
  equation 
    // balon1
    der(v1) = q1_b;
    p1 = c1 * v1;
    // odpor
    q1_b + q1_r = 0; // otaci znaminka vstupniho toku pro logiku veci
    p1 - p2 = r * q1_r;
    q1_r + q2_r = 0;
    q2_b + q2_r = 0; // otaci znaminka vystupniho toku pro logiku veci
    // balon2
    der(v2) = q2_b;
    p2 = c2 * v2;
    annotation(Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})));
  end balonyEq;
  
  connector pq 
    Real p "tlak, dejme tomu Pa";
    flow Real q "Tok v m3/s";
    annotation(Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})));
  end pq;
  
  model balon 
    
    pq pq1 annotation(Placement(visible = true, transformation(origin = {80, -86}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {80, -86}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Real v;
    parameter Real c = 1;
  equation 
    der(v) = pq1.q;
    pq1.p = c * v;
    annotation(Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})));
  end balon;
  
  model odpor 
    
    pq pq1 annotation(Placement(visible = true, transformation(origin = {-92, 6}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-92, 6}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    pq pq2 annotation(Placement(visible = true, transformation(origin = {84, 4}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {84, 4}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    parameter Real r = 1;
  equation 
    //q1_b = - q1_r; // tohle jiz nepotrebujeme, protoze otoceni nam zajisti propojeni konektory
    pq1.p - pq2.p = r * pq1.q;
    pq1.q + pq2.q = 0;
    //q2_b = - q2_r; // stejne tak
    annotation(Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})));
  end odpor;
  
  model balonkySystem 
    
    balon balon1 annotation(Placement(visible = true, transformation(origin = {-66, 24}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    balon balon2 annotation(Placement(visible = true, transformation(origin = {74, 30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    odpor odpor1 annotation(Placement(visible = true, transformation(origin = {8, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  initial equation 
    balon1.v = 2;
    balon2.v = 0;
  equation 
    //balon1.pq1.p = odpor1.pq1.p;
    //balon1.pq1.q + odpor1.pq1.q = 0;
    connect(balon1.pq1, odpor1.pq1); // tahle "rovnice" ma stejny vyznam jako ty dve vys
    
    //balon2.pq1.p = odpor1.pq2.p;
    //balon2.pq1.q + odpor1.pq2.q = 0;
    connect(balon2.pq1, odpor1.pq2); // stejne tak
    annotation(Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})));
  end balonkySystem;
  annotation(Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), uses(Modelica(version = "2.2.2")));
end mos2;
